#!/usr/bin/env python
#
# Copyright (C) 2014  Google Inc.
#
# This file is part of YouCompleteMe.
#
# YouCompleteMe is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# YouCompleteMe is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with YouCompleteMe.  If not, see <http://www.gnu.org/licenses/>.

import json
import os
import ycm_core

# These are the compilation flags that will be used in case there's no
# compilation database set (by default, one is not set).
# CHANGE THIS LIST OF FLAGS. YES, THIS IS THE DROID YOU HAVE BEEN LOOKING FOR.
flags = [
'-Wall',
'-Wextra',
'-fexceptions',
'-DNDEBUG',
# THIS IS IMPORTANT! Without a "-std=<something>" flag, clang won't know which
# language to use when compiling headers. So it will guess. Badly. So C++
# headers will be compiled as C headers. You don't want that so ALWAYS specify
# a "-std=<something>".
# For a C project, you would set this to something like 'c99' instead of
# 'c++11'.
'-std=c++17',
# ...and the same thing goes for the magic -x option which specifies the
# language that the files to be compiled are written in. This is mostly
# relevant for c++ headers.
# For a C project, you would set this to 'c' instead of 'c++'.
'-x',
'c++',
]


# Set this to the absolute path to the folder (NOT the file!) containing the
# compile_commands.json file to use that instead of 'flags'. See here for
# more details: http://clang.llvm.org/docs/JSONCompilationDatabase.html
#
# Most projects will NOT need to set this to anything; you can just change the
# 'flags' list of compilation flags.
compilation_database_folder = ''

if os.path.exists( compilation_database_folder ):
  database = ycm_core.CompilationDatabase( compilation_database_folder )
else:
  database = None

SOURCE_EXTENSIONS = [ '.cpp', '.cxx', '.cc', '.c', '.m', '.mm' ]

def DirectoryOfThisScript():
  return os.path.dirname( os.path.abspath( __file__ ) )


def MakeRelativePathsInFlagsAbsolute( flags, working_directory ):
  if not working_directory:
    return list( flags )
  new_flags = []
  make_next_absolute = False
  path_flags = [ '-isystem', '-I', '-iquote', '--sysroot=' ]
  for flag in flags:
    new_flag = flag

    if make_next_absolute:
      make_next_absolute = False
      if not flag.startswith( '/' ):
        new_flag = os.path.join( working_directory, flag )

    for path_flag in path_flags:
      if flag == path_flag:
        make_next_absolute = True
        break

      if flag.startswith( path_flag ):
        path = flag[ len( path_flag ): ]
        new_flag = path_flag + os.path.join( working_directory, path )
        break

    if new_flag:
      new_flags.append( new_flag )
  return new_flags


def IsHeaderFile( filename ):
  extension = os.path.splitext( filename )[ 1 ]
  return extension in [ '.h', '.hxx', '.hpp', '.hh' ]


def GetCompilationInfoForFile( filename ):
  # The compilation_commands.json file generated by CMake does not have entries
  # for header files. So we do our best by asking the db for flags for a
  # corresponding source file, if any. If one exists, the flags for that file
  # should be good enough.
  if IsHeaderFile( filename ):
    basename = os.path.splitext( filename )[ 0 ]
    for extension in SOURCE_EXTENSIONS:
      replacement_file = basename + extension
      if os.path.exists( replacement_file ):
        compilation_info = database.GetCompilationInfoForFile(
          replacement_file )
        if compilation_info.compiler_flags_:
          return compilation_info
    return None
  return database.GetCompilationInfoForFile( filename )


def UEDirectoryOfJson():
    return 'Intermediate\ProjectFiles\.Rider\Win64\Development\Editor'


def UEProjectName():
    files = os.listdir(DirectoryOfThisScript())
    pfiles = [p for p in files if p.endswith('.uproject')]
    return os.path.splitext(pfiles[0])[0] if len(pfiles) else None


def UEPathOfJson(project):
    json_dir = UEDirectoryOfJson()
    if not project:
        return None
    json_name = project + '.json'
    path = os.path.join(json_dir, json_name)
    return path if os.path.exists(path) else None


def UELoadJson(project):
    path = UEPathOfJson(project)
    if not path:
        return None
    with open(path) as f:
        cfg = json.load(f)
    return cfg


def UEEnginePath(cfg):
    p = cfg['Modules']['Engine']['Directory']
    return os.path.dirname(
             os.path.dirname(
               os.path.dirname(p)))


def UEIsSystemPath(engine_path, path):
    return os.path.samefile(engine_path,
             os.path.commonpath([engine_path, path]))


def UEIncludePathFlag(engine_path, path):
    is_system = UEIsSystemPath(engine_path, path)
    return ['-I', '-isystem'][is_system]


def UEAddIncludePaths(paths, engine_path, epaths, flags):
    for p in paths:
        if p in epaths:
            continue
        flag = UEIncludePathFlag(engine_path, p)
        flags.extend([flag, p])
        epaths.add(p)


def UEAddDefinitions(defs, edefs, flags):
    for d in defs:
        if d in edefs:
            continue
        flags.append('-D' + d)
        edefs.add(d)


def UEGetEnvironmentFlags(cfg, engine_path, epaths, edefs, flags):
    paths = cfg['EnvironmentIncludePaths']
    UEAddIncludePaths(paths, engine_path, epaths, flags)
    defs = cfg['EnvironmentDefinitions']
    UEAddDefinitions(defs, edefs, flags)


def UEAddModuleFlags(module, cfg, engine_path, epaths, edefs, emodules, flags):
    if module not in cfg['Modules'].keys():
        return
    m = cfg['Modules'][module]
    inc_keys = [
        'PublicIncludePaths',
        'PublicSystemIncludePaths',
        #'LegacyPublicIncludePaths',
        #'PrivateIncludePaths',
    ]
    for k in inc_keys:
        if k in m.keys():
            UEAddIncludePaths(m[k], engine_path, epaths, flags)
    def_keys = [
        'ApiDefinitions',
        'ProjectDefinitions',
        'PublicDefinitions',
        #'PrivateDefinitions',
    ]
    for d in def_keys:
        if d in m.keys():
            UEAddDefinitions(m[d], edefs, flags)
    if 'GeneratedCodeDirectory' in m.keys():
        gen_code_dirs = [m['GeneratedCodeDirectory']]
        UEAddIncludePaths(gen_code_dirs, engine_path, epaths, flags)
    emodules.add(module)
    mod_keys = [
        'PublicDependencyModules',
        'PublicIncludePathModules',
        #'PrivateDependencyModules',
        #'PrivateIncludePathModules',
    ]
    for k in mod_keys:
        if k in m.keys():
            for dm in m[k]:
                if not dm in emodules:
                    UEAddModuleFlags(dm, cfg, engine_path, epaths, edefs, emodules, flags)


def UEGetCompileFlags():
    project = UEProjectName()
    cfg = UELoadJson(project)
    engine_path = UEEnginePath(cfg)
    epaths = set()
    edefs = set()
    emodules = set()
    flags = []
    UEGetEnvironmentFlags(cfg, engine_path, epaths, edefs, flags)
    UEAddModuleFlags(project, cfg, engine_path, epaths, edefs, emodules, flags)
    return flags


# This is the entry point; this function is called by ycmd to produce flags for
# a file.
def FlagsForFile( filename, **kwargs ):
  flags.extend(UEGetCompileFlags())

  if database:
    # Bear in mind that compilation_info.compiler_flags_ does NOT return a
    # python list, but a "list-like" StringVec object
    compilation_info = GetCompilationInfoForFile( filename )
    if not compilation_info:
      return None

    final_flags = MakeRelativePathsInFlagsAbsolute(
      compilation_info.compiler_flags_,
      compilation_info.compiler_working_dir_ )
  else:
    relative_to = DirectoryOfThisScript()
    final_flags = MakeRelativePathsInFlagsAbsolute( flags, relative_to )

  return {
    'flags': final_flags,
    'do_cache': True
  }

